%----------------------------------------------------------------------
% compiler.pl
%
% version 2.0, 2003-2008 (This version runs only for SICStus-Prolog.)
%
% Linh Anh Nguyen, 
% Institute of Informatics
% Warsaw University
% nguyen@mimuw.edu.pl
%
%----------------------------------------------------------------------

compile_built_in_calculi :- 
	write('Loading calculi from smnm.cal, belief.cal, groups.cal, belief_box.cal.'), nl, 
	consult_calculi('smnm.cal'),
	consult_calculi('belief.cal'),
	consult_calculi('groups.cal'),
	consult_calculi('belief_box.cal'),
	compile_loaded_calculi.

compile_loaded_calculi :- mcompile(calculi).
compile_loaded_program :- mcompile(program).

mcompile(Type) :- 
	(Type = calculi ->
	   (write('Compiling MProlog and the loaded calculi.'), nl, 
	    write('The result is writen to mprolog.po.'), nl); 
	   (write('Compiling the loaded program.'), 
	    write('The result will be writen to program.po.'), nl)), 

	tell('compile_temp.pl'),

	write(':- use_module(library(lists)).'), nl,
	write(':- use_module(library(random)).'), nl,
	write(':- use_module(library(system)).'), nl, 
	
	write(':- dynamic option/2, option/3, info/2.'), nl,
	write(':- dynamic calling_history/4.'), nl,
	write(':- dynamic locally_completed/2, called/2.'), nl,
	write(':- dynamic tabled/4, tabulation_size/1.'), nl,
	write(':- dynamic answer/1.'), nl,

	(Type = program -> true; 
	 write(':- dynamic list_of_preds/2.'), nl,
	 write(':- dynamic mclause/5.'), nl,
	 write(':- dynamic list_of_mclauses/3.'), nl), 

	write(':- op(1150, fx, pre_rSat).'), nl,
	write(':- op(1150, fx, rSat).'), nl,
	write(':- op(1150, fx, post_rSat).'), nl,
	write(':- op(1150, fx, rNF).'), nl,
	write(':- op(1150, fx, calculus).'), nl,
	write(':- op(1150, fx, end).'), nl,
	write(':- op(1150, fx, dum_pred).'), nl,
	write(':- op(1200, xfx, ::).'), nl,

	listing,

	(Type = program -> true;  
	 write(':- retractall(user:list_of_preds(modal,_)).'), nl,
	 write(':- retractall(user:list_of_preds(dum,_)).'), nl,
	 write(':- assert(user:list_of_preds(modal,[])).'), nl,
	 write(':- assert(user:list_of_preds(dum,[])).'), nl),

	told,

	(Type = calculi -> 
	   write('RESTART Prolog and consult compile_c.pl to finish.'); 
	   write('RESTART Prolog and consult compile_p.pl to finish.')), 
	nl, nl.
